/*
 * Copyright (C) 2024 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.android.federatedcompute.services.statsd;

import com.android.ondevicepersonalization.internal.util.DataClass;

/**
 * Class holds ExampleIteratorNextLatencyReported defined at
 * frameworks/proto_logging/stats/atoms/federatedcompute/federatedcompute_extension_atoms.proto
 */
@DataClass(genBuilder = true, genEqualsHashCode = true)
public class ExampleIteratorLatency {
    private long mClientVersion;
    private long mTaskId;
    private long mGetNextLatencyNanos;

    // Code below generated by codegen v1.0.23.
    //
    // DO NOT MODIFY!
    // CHECKSTYLE:OFF Generated code
    //
    // To regenerate run:
    // $ codegen
    // $ANDROID_BUILD_TOP/packages/modules/OnDevicePersonalization/federatedcompute/src/com/android/federatedcompute/services/statsd/ExampleIteratorLatency.java
    //
    // To exclude the generated code from IntelliJ auto-formatting enable (one-time):
    //   Settings > Editor > Code Style > Formatter Control
    // @formatter:off

    @DataClass.Generated.Member
    /* package-private */ ExampleIteratorLatency(
            long clientVersion, long taskId, long getNextLatencyNanos) {
        this.mClientVersion = clientVersion;
        this.mTaskId = taskId;
        this.mGetNextLatencyNanos = getNextLatencyNanos;

        // onConstructed(); // You can define this method to get a callback
    }

    @DataClass.Generated.Member
    public long getClientVersion() {
        return mClientVersion;
    }

    @DataClass.Generated.Member
    public long getTaskId() {
        return mTaskId;
    }

    @DataClass.Generated.Member
    public long getGetNextLatencyNanos() {
        return mGetNextLatencyNanos;
    }

    @Override
    @DataClass.Generated.Member
    public boolean equals(@android.annotation.Nullable Object o) {
        // You can override field equality logic by defining either of the methods like:
        // boolean fieldNameEquals(ExampleIteratorLatency other) { ... }
        // boolean fieldNameEquals(FieldType otherValue) { ... }

        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        @SuppressWarnings("unchecked")
        ExampleIteratorLatency that = (ExampleIteratorLatency) o;
        //noinspection PointlessBooleanExpression
        return true
                && mClientVersion == that.mClientVersion
                && mTaskId == that.mTaskId
                && mGetNextLatencyNanos == that.mGetNextLatencyNanos;
    }

    @Override
    @DataClass.Generated.Member
    public int hashCode() {
        // You can override field hashCode logic by defining methods like:
        // int fieldNameHashCode() { ... }

        int _hash = 1;
        _hash = 31 * _hash + Long.hashCode(mClientVersion);
        _hash = 31 * _hash + Long.hashCode(mTaskId);
        _hash = 31 * _hash + Long.hashCode(mGetNextLatencyNanos);
        return _hash;
    }

    /** A builder for {@link ExampleIteratorLatency} */
    @SuppressWarnings("WeakerAccess")
    @DataClass.Generated.Member
    public static class Builder {

        private long mClientVersion;
        private long mTaskId;
        private long mGetNextLatencyNanos;

        private long mBuilderFieldsSet = 0L;

        public Builder() {}

        @DataClass.Generated.Member
        public @android.annotation.NonNull Builder setClientVersion(long value) {
            checkNotUsed();
            mBuilderFieldsSet |= 0x1;
            mClientVersion = value;
            return this;
        }

        @DataClass.Generated.Member
        public @android.annotation.NonNull Builder setTaskId(long value) {
            checkNotUsed();
            mBuilderFieldsSet |= 0x2;
            mTaskId = value;
            return this;
        }

        @DataClass.Generated.Member
        public @android.annotation.NonNull Builder setGetNextLatencyNanos(long value) {
            checkNotUsed();
            mBuilderFieldsSet |= 0x4;
            mGetNextLatencyNanos = value;
            return this;
        }

        /** Builds the instance. This builder should not be touched after calling this! */
        public @android.annotation.NonNull ExampleIteratorLatency build() {
            checkNotUsed();
            mBuilderFieldsSet |= 0x8; // Mark builder used

            ExampleIteratorLatency o =
                    new ExampleIteratorLatency(mClientVersion, mTaskId, mGetNextLatencyNanos);
            return o;
        }

        private void checkNotUsed() {
            if ((mBuilderFieldsSet & 0x8) != 0) {
                throw new IllegalStateException(
                        "This Builder should not be reused. Use a new Builder instance instead");
            }
        }
    }

    @DataClass.Generated(
            time = 1710536954249L,
            codegenVersion = "1.0.23",
            sourceFile =
                    "packages/modules/OnDevicePersonalization/federatedcompute/src/com/android/federatedcompute/services/statsd/ExampleIteratorLatency.java",
            inputSignatures =
                    "private  long mClientVersion\nprivate  long mTaskId\nprivate  long mGetNextLatencyNanos\nclass ExampleIteratorLatency extends java.lang.Object implements []\n@com.android.ondevicepersonalization.internal.util.DataClass(genBuilder=true, genEqualsHashCode=true)")
    @Deprecated
    private void __metadata() {}

    // @formatter:on
    // End of generated code

}
